package info.hostip.dao.mgr;

import java.io.InputStream;
import java.net.URL;
import java.sql.*;
import java.util.Date;
import info.hostip.util.PropertiesHelper;


/** This is the manager class.
 * @author <a href="mailto:vinodpillai@excite.com">Vinod Pillai</a>
 */
public class Manager {

	private static final String SQL_QUOTE = "'";

	/***** YOU NEED TO IMPLEMENT THESE METHODS: *****/

	public Connection openConnection() throws SQLException {
		
		Connection connection = null;
		
		try {
			// Wire this method up to your JDBC Conetnection pool
			// or create a new connection each time (gasp)
			
			URL[] urls = PropertiesHelper.instance().findProperties(Manager.class, "db.properties");
			
			for(int i = 0; i < urls.length; i++) {
				InputStream in = urls[i].openStream();
				System.getProperties().load(in);
				
			}
			
			String className = System.getProperty("info.hostip.jdbc.driver");
			String jdbcUrl = System.getProperty("info.hostip.jdbc.url");
			String usr = System.getProperty("info.hostip.jdbc.username");
			String pwd = System.getProperty("info.hostip.jdbc.password");
			Class.forName(className);
			connection = DriverManager.getConnection(jdbcUrl, usr, pwd);
		}

		catch(Exception e) {
			throw new SQLException(e);
		}
		return connection;
	}

	public void closeConnection(Connection conn) throws SQLException {
		// Return the connection back to the pool
		// or simply call conn.close() on it if there's no pool (gasp)
	}

	public String dateToString(Date date) {
		// Return a String representation of this date that your database
		// will understand.  Make sure to enclose it in single quotes if 
		// required (ie. the Manager subclasses won't add them for you
		return null;
	}


	/***** THESE METHODS ARE IMPLEMENTED FOR YOU: *****/

	public String booleanToString(boolean b, boolean quote) {
		if(b) { return (quote) ? "'Y'" : "Y"; }
		else  { return (quote) ? "'N'" : "N"; }
	}

	public boolean stringToBoolean(String s) {
		if(s == null || !s.equals("Y")) return false;
		else                              return true;
	}
	public char stringToChar(String s) {
		if(s == null) return ' ';
		char list[] = s.toCharArray();
		if(list.length > 0) return list[0];
		else                return ' ';
	}

	public String charToString(char c) {
		char list[] = new char[1];
		list[0] = c;
		return new String(list);
	}

	public String escapeString(String str, int maxLen, boolean quote) {
		if(str == null) {
			if(quote) return SQL_QUOTE + SQL_QUOTE;
			else      return "";
		}

		int strLen = str.length();
		if(strLen > maxLen) str = str.substring(0, maxLen);

		StringBuffer buf = new StringBuffer(strLen + 20);
		if(quote) buf.append(SQL_QUOTE);

		int start = 0;
		int end = str.indexOf(SQL_QUOTE);
		while(end != -1) {
			buf.append(str.substring(start, end));
			buf.append(SQL_QUOTE).append(SQL_QUOTE);
			start = end;
			if(start < strLen - 1) end = str.indexOf(SQL_QUOTE, ++start);
			else end = -1;
		}
		if(start < strLen && !str.endsWith(SQL_QUOTE)) {
			buf.append(str.substring(start));
		}

		if(quote) buf.append(SQL_QUOTE);
		return buf.toString();
	}

}
